Index: uspace/srv/fs/fat/fat_dentry.h
===================================================================
--- uspace/srv/fs/fat/fat_dentry.h	(revision 375ab5e571cc53eeb2aa803a8e86052b51d7ad00)
+++ uspace/srv/fs/fat/fat_dentry.h	(revision 7fadb6526b88d8a8d0bbeb5d5997969a53e7e66d)
@@ -1,5 +1,4 @@
 /*
  * Copyright (c) 2008 Jakub Jermar
- * Copyright (c) 2011 Oleg Romanenko
  * All rights reserved.
  *
@@ -38,7 +37,4 @@
 #include <bool.h>
 
-#define IS_D_CHAR(ch) (isalnum(ch) || ch == '_')
-#define FAT_STOP_CHARS L"*?/\\\n\t|'"
-
 #define FAT_NAME_LEN		8
 #define FAT_EXT_LEN		3
@@ -48,19 +44,12 @@
 #define FAT_EXT_PAD		"   "
 
-#define FAT_ATTR_RDONLY   0x01
-#define FAT_ATTR_HIDDEN   0x02
-#define FAT_ATTR_SYSTEM   0x04
-#define FAT_ATTR_VOLLABEL 0x08
-#define FAT_ATTR_SUBDIR   0x10
-#define FAT_ATTR_ARCHIVE  0x20
-#define FAT_ATTR_LFN \
-    (FAT_ATTR_RDONLY | FAT_ATTR_HIDDEN | FAT_ATTR_SYSTEM | FAT_ATTR_VOLLABEL)
-    
+#define FAT_ATTR_RDONLY		(1 << 0)
+#define FAT_ATTR_VOLLABEL	(1 << 3)
+#define FAT_ATTR_SUBDIR		(1 << 4)
+
 #define FAT_LCASE_LOWER_NAME	0x08
 #define FAT_LCASE_LOWER_EXT	0x10
 
-#define FAT_PAD			' '
-#define FAT_LFN_PAD	0xffff
-#define FAT_SFN_CHAR '_'
+#define FAT_PAD			' ' 
 
 #define FAT_DENTRY_UNUSED	0x00
@@ -68,25 +57,4 @@
 #define FAT_DENTRY_DOT		0x2e
 #define FAT_DENTRY_ERASED	0xe5
-#define FAT_LFN_LAST		0x40
-#define FAT_LFN_ERASED		0x80
-
-#define FAT_LFN_ORDER(d) (d->lfn.order)
-#define FAT_IS_LFN(d) \
-    ((FAT_LFN_ORDER(d) & FAT_LFN_LAST) == FAT_LFN_LAST)
-#define FAT_LFN_COUNT(d) \
-    (FAT_LFN_ORDER(d) ^ FAT_LFN_LAST)
-#define FAT_LFN_PART1(d) (d->lfn.part1)
-#define FAT_LFN_PART2(d) (d->lfn.part2)
-#define FAT_LFN_PART3(d) (d->lfn.part3)
-#define FAT_LFN_ATTR(d) (d->lfn.attr)
-#define FAT_LFN_CHKSUM(d) (d->lfn.check_sum)
-
-#define FAT_LFN_NAME_SIZE   260
-#define FAT_LFN_MAX_COUNT   20
-#define FAT_LFN_PART1_SIZE  5
-#define FAT_LFN_PART2_SIZE  6
-#define FAT_LFN_PART3_SIZE  2
-#define FAT_LFN_ENTRY_SIZE \
-    (FAT_LFN_PART1_SIZE + FAT_LFN_PART2_SIZE + FAT_LFN_PART3_SIZE)
 
 typedef enum {
@@ -94,62 +62,34 @@
 	FAT_DENTRY_LAST,
 	FAT_DENTRY_FREE,
-	FAT_DENTRY_VALID,
-	FAT_DENTRY_LFN
+	FAT_DENTRY_VALID
 } fat_dentry_clsf_t;
 
 typedef struct {
+	uint8_t		name[8];
+	uint8_t		ext[3];
+	uint8_t		attr;
+	uint8_t		lcase;
+	uint8_t		ctime_fine;
+	uint16_t	ctime;
+	uint16_t	cdate;
+	uint16_t	adate;
 	union {
-		struct {
-			uint8_t		name[8];
-			uint8_t		ext[3];
-			uint8_t		attr;
-			uint8_t		lcase;
-			uint8_t		ctime_fine;
-			uint16_t	ctime;
-			uint16_t	cdate;
-			uint16_t	adate;
-			union {
-				uint16_t	eaidx;		/* FAT12/FAT16 */
-				uint16_t	firstc_hi;	/* FAT32 */
-			} __attribute__ ((packed));
-			uint16_t	mtime;
-			uint16_t	mdate;
-			union {
-				uint16_t	firstc;		/* FAT12/FAT16 */
-				uint16_t	firstc_lo;	/* FAT32 */
-			} __attribute__ ((packed));
-			uint32_t	size;
-		} __attribute__ ((packed));
-		struct {
-			uint8_t		order;
-			uint16_t	part1[FAT_LFN_PART1_SIZE];
-			uint8_t		attr;
-			uint8_t		type;
-			uint8_t		check_sum;
-			uint16_t	part2[FAT_LFN_PART2_SIZE];
-			uint16_t	firstc_lo; /* MUST be 0 */
-			uint16_t	part3[FAT_LFN_PART3_SIZE];
-		} __attribute__ ((packed)) lfn;
-	};
+		uint16_t	eaidx;		/* FAT12/FAT16 */
+		uint16_t	firstc_hi;	/* FAT32 */
+	} __attribute__ ((packed));
+	uint16_t	mtime;
+	uint16_t	mdate;
+	union {
+		uint16_t	firstc;		/* FAT12/FAT16 */
+		uint16_t	firstc_lo;	/* FAT32 */
+	} __attribute__ ((packed));
+	uint32_t	size;
 } __attribute__ ((packed)) fat_dentry_t;
 
-
 extern int fat_dentry_namecmp(char *, const char *);
+extern bool fat_dentry_name_verify(const char *);
 extern void fat_dentry_name_get(const fat_dentry_t *, char *);
 extern void fat_dentry_name_set(fat_dentry_t *, const char *);
 extern fat_dentry_clsf_t fat_classify_dentry(const fat_dentry_t *);
-extern uint8_t fat_dentry_chksum(uint8_t *);
-
-extern size_t fat_lfn_str_nlength(const uint16_t *, size_t);
-extern size_t fat_lfn_size(const fat_dentry_t *);
-extern size_t fat_lfn_get_entry(const fat_dentry_t *, uint16_t *, size_t *);
-extern size_t fat_lfn_set_entry(const uint16_t *, size_t *, size_t, fat_dentry_t *);
-
-extern void str_to_ascii(char *dst, const char *src, size_t count, uint8_t pad);
-extern size_t utf16_length(const uint16_t *wstr);
-
-extern bool fat_valid_name(const char *name);
-extern bool fat_valid_short_name(const char *name);
-
 
 #endif
Index: uspace/srv/fs/fat/fat_fat.c
===================================================================
--- uspace/srv/fs/fat/fat_fat.c	(revision 375ab5e571cc53eeb2aa803a8e86052b51d7ad00)
+++ uspace/srv/fs/fat/fat_fat.c	(revision 7fadb6526b88d8a8d0bbeb5d5997969a53e7e66d)
@@ -1,5 +1,4 @@
 /*
  * Copyright (c) 2008 Jakub Jermar
- * Copyright (c) 2011 Oleg Romanenko
  * All rights reserved.
  *
@@ -30,5 +29,5 @@
 /** @addtogroup fs
  * @{
- */
+ */ 
 
 /**
@@ -55,8 +54,10 @@
  * primitive boot sector members.
  */
+#define RDS(bs)		((sizeof(fat_dentry_t) * RDE((bs))) / BPS((bs))) + \
+			(((sizeof(fat_dentry_t) * RDE((bs))) % BPS((bs))) != 0)
+#define SSA(bs)		(RSCNT((bs)) + FATCNT((bs)) * SF((bs)) + RDS(bs))
+
 #define CLBN2PBN(bs, cl, bn) \
 	(SSA((bs)) + ((cl) - FAT_CLST_FIRST) * SPC((bs)) + (bn) % SPC((bs)))
-
-#define IS_ODD(number)	(number & 0x1)
 
 /**
@@ -64,5 +65,5 @@
  * during allocation of clusters. The lock does not have to be held durring
  * deallocation of clusters.
- */
+ */  
 static FIBRIL_MUTEX_INITIALIZE(fat_alloc_lock);
 
@@ -76,15 +77,15 @@
  * @param numc		If non-NULL, output argument holding the number of
  *			clusters seen during the walk.
- * @param max_clusters	Maximum number of clusters to visit.
+ * @param max_clusters	Maximum number of clusters to visit.	
  *
  * @return		EOK on success or a negative error code.
  */
-int
+int 
 fat_cluster_walk(fat_bs_t *bs, service_id_t service_id, fat_cluster_t firstc,
-    fat_cluster_t *lastc, uint32_t *numc, uint32_t max_clusters)
-{
-	uint32_t clusters = 0;
-	fat_cluster_t clst = firstc, clst_last1 = FAT_CLST_LAST1(bs);
-	fat_cluster_t clst_bad = FAT_CLST_BAD(bs);
+    fat_cluster_t *lastc, uint16_t *numc, uint16_t max_clusters)
+{
+	block_t *b;
+	uint16_t clusters = 0;
+	fat_cluster_t clst = firstc;
 	int rc;
 
@@ -98,19 +99,27 @@
 	}
 
-	while (clst < clst_last1 && clusters < max_clusters) {
+	while (clst < FAT_CLST_LAST1 && clusters < max_clusters) {
+		aoff64_t fsec;	/* sector offset relative to FAT1 */
+		unsigned fidx;	/* FAT1 entry index */
+
 		assert(clst >= FAT_CLST_FIRST);
 		if (lastc)
 			*lastc = clst;	/* remember the last cluster number */
-
+		fsec = (clst * sizeof(fat_cluster_t)) / BPS(bs);
+		fidx = clst % (BPS(bs) / sizeof(fat_cluster_t));
 		/* read FAT1 */
-		rc = fat_get_cluster(bs, service_id, FAT1, clst, &clst);
-		if (rc != EOK)
-			return rc;
-
-		assert(clst != clst_bad);
+		rc = block_get(&b, service_id, RSCNT(bs) + fsec,
+		    BLOCK_FLAGS_NONE);
+		if (rc != EOK)
+			return rc;
+		clst = uint16_t_le2host(((fat_cluster_t *)b->data)[fidx]);
+		assert(clst != FAT_CLST_BAD);
+		rc = block_put(b);
+		if (rc != EOK)
+			return rc;
 		clusters++;
 	}
 
-	if (lastc && clst < clst_last1)
+	if (lastc && clst < FAT_CLST_LAST1)
 		*lastc = clst;
 	if (numc)
@@ -142,5 +151,5 @@
 		return ELIMIT;
 
-	if (!FAT_IS_FAT32(bs) && nodep->firstc == FAT_CLST_ROOT)
+	if (nodep->firstc == FAT_CLST_ROOT) 
 		goto fall_through;
 
@@ -169,5 +178,5 @@
 	if (rc != EOK)
 		return rc;
-
+	
 	/*
 	 * Update the "current" cluster cache.
@@ -189,5 +198,5 @@
  * @param clp		If not NULL, address where the cluster containing bn
  *			will be stored.
- *			stored
+ *			stored 
  * @param bn		Block number.
  * @param flags		Flags passed to libblock.
@@ -199,6 +208,6 @@
     fat_cluster_t fcl, fat_cluster_t *clp, aoff64_t bn, int flags)
 {
-	uint32_t clusters;
-	uint32_t max_clusters;
+	uint16_t clusters;
+	unsigned max_clusters;
 	fat_cluster_t c;
 	int rc;
@@ -210,5 +219,5 @@
 		return ELIMIT;
 
-	if (!FAT_IS_FAT32(bs) && fcl == FAT_CLST_ROOT) {
+	if (fcl == FAT_CLST_ROOT) {
 		/* root directory special case */
 		assert(bn < RDS(bs));
@@ -266,8 +275,8 @@
 			return rc;
 	}
-
+	
 	if (o >= pos)
 		return EOK;
-
+	
 	/* zero out the initial part of the new cluster chain */
 	for (o = boundary; o < pos; o += BPS(bs)) {
@@ -286,5 +295,5 @@
 }
 
-/** Get cluster from the first FAT. FAT12 version
+/** Get cluster from the first FAT.
  *
  * @param bs		Buffer holding the boot sector for the file system.
@@ -296,310 +305,20 @@
  */
 int
-fat_get_cluster_fat12(fat_bs_t *bs, service_id_t service_id, unsigned fatno,
+fat_get_cluster(fat_bs_t *bs, service_id_t service_id, unsigned fatno,
     fat_cluster_t clst, fat_cluster_t *value)
 {
-	block_t *b, *b1;
-	uint16_t byte1, byte2;
-	aoff64_t offset;
-	int rc;
-
-	offset = (clst + clst/2);
-	if (offset / BPS(bs) >= SF(bs))
-		return ERANGE;
+	block_t *b;
+	fat_cluster_t *cp;
+	int rc;
 
 	rc = block_get(&b, service_id, RSCNT(bs) + SF(bs) * fatno +
-	    offset / BPS(bs), BLOCK_FLAGS_NONE);
+	    (clst * sizeof(fat_cluster_t)) / BPS(bs), BLOCK_FLAGS_NONE);
 	if (rc != EOK)
 		return rc;
-
-	byte1 = ((uint8_t*) b->data)[offset % BPS(bs)];
-	/* This cluster access spans a sector boundary. Check only for FAT12 */
-	if ((offset % BPS(bs)) + 1 == BPS(bs)) {
-		/* Is it last sector of FAT? */
-		if (offset / BPS(bs) < SF(bs)) {
-			/* No. Reading next sector */
-			rc = block_get(&b1, service_id, 1 + RSCNT(bs) +
-				SF(bs)*fatno + offset / BPS(bs), BLOCK_FLAGS_NONE);
-			if (rc != EOK) {
-				block_put(b);
-				return rc;
-			}
-			/*
-			* Combining value with last byte of current sector and
-			* first byte of next sector
-			*/
-			byte2 = ((uint8_t*) b1->data)[0];
-
-			rc = block_put(b1);
-			if (rc != EOK) {
-				block_put(b);
-				return rc;
-			}
-		}
-		else {
-			/* Yes. It is last sector of FAT */
-			block_put(b);
-			return ERANGE;
-		}
-	}
-	else
-		byte2 = ((uint8_t*) b->data)[(offset % BPS(bs))+1];
-
-	*value = uint16_t_le2host(byte1 | (byte2 << 8));
-	if (IS_ODD(clst))
-		*value = (*value) >> 4;
-	else
-		*value = (*value) & FAT12_MASK;
+	cp = (fat_cluster_t *)b->data +
+	    clst % (BPS(bs) / sizeof(fat_cluster_t));
+	*value = uint16_t_le2host(*cp);
+	rc = block_put(b);
 	
-	rc = block_put(b);
-	return rc;
-}
-
-/** Get cluster from the first FAT. FAT16 version
- *
- * @param bs		Buffer holding the boot sector for the file system.
- * @param service_id	Service ID for the file system.
- * @param clst		Cluster which to get.
- * @param value		Output argument holding the value of the cluster.
- *
- * @return		EOK or a negative error code.
- */
-int
-fat_get_cluster_fat16(fat_bs_t *bs, service_id_t service_id, unsigned fatno,
-    fat_cluster_t clst, fat_cluster_t *value)
-{
-	block_t *b;
-	aoff64_t offset;
-	int rc;
-
-	offset = (clst * FAT16_CLST_SIZE);
-
-	rc = block_get(&b, service_id, RSCNT(bs) + SF(bs) * fatno +
-	    offset / BPS(bs), BLOCK_FLAGS_NONE);
-	if (rc != EOK)
-		return rc;
-
-	*value = uint16_t_le2host(*(uint16_t *)(b->data + offset % BPS(bs)));
-
-	rc = block_put(b);
-
-	return rc;
-}
-
-/** Get cluster from the first FAT. FAT32 version
- *
- * @param bs		Buffer holding the boot sector for the file system.
- * @param service_id	Service ID for the file system.
- * @param clst		Cluster which to get.
- * @param value		Output argument holding the value of the cluster.
- *
- * @return		EOK or a negative error code.
- */
-int
-fat_get_cluster_fat32(fat_bs_t *bs, service_id_t service_id, unsigned fatno,
-    fat_cluster_t clst, fat_cluster_t *value)
-{
-	block_t *b;
-	aoff64_t offset;
-	int rc;
-
-	offset = (clst * FAT32_CLST_SIZE);
-
-	rc = block_get(&b, service_id, RSCNT(bs) + SF(bs) * fatno +
-	    offset / BPS(bs), BLOCK_FLAGS_NONE);
-	if (rc != EOK)
-		return rc;
-
-	*value = uint32_t_le2host(*(uint32_t *)(b->data + offset % BPS(bs))) & FAT32_MASK;
-
-	rc = block_put(b);
-
-	return rc;
-}
-
-
-/** Get cluster from the first FAT.
- *
- * @param bs		Buffer holding the boot sector for the file system.
- * @param service_id	Service ID for the file system.
- * @param clst		Cluster which to get.
- * @param value		Output argument holding the value of the cluster.
- *
- * @return		EOK or a negative error code.
- */
-int
-fat_get_cluster(fat_bs_t *bs, service_id_t service_id, unsigned fatno,
-    fat_cluster_t clst, fat_cluster_t *value)
-{
-	int rc;
-
-	assert(fatno < FATCNT(bs));
-
-	if (FAT_IS_FAT12(bs)) {
-		rc = fat_get_cluster_fat12(bs, service_id, fatno, clst, value);
-	}
-	else {
-		if (FAT_IS_FAT32(bs))
-			rc = fat_get_cluster_fat32(bs, service_id, fatno, clst, value);
-		else
-			rc = fat_get_cluster_fat16(bs, service_id, fatno, clst, value);
-	}
-
-	return rc;
-}
-
-/** Set cluster in one instance of FAT. FAT12 version.
- *
- * @param bs		Buffer holding the boot sector for the file system.
- * @param service_id	Service ID for the file system.
- * @param fatno		Number of the FAT instance where to make the change.
- * @param clst		Cluster which is to be set.
- * @param value		Value to set the cluster with.
- *
- * @return		EOK on success or a negative error code.
- */
-int
-fat_set_cluster_fat12(fat_bs_t *bs, service_id_t service_id, unsigned fatno,
-    fat_cluster_t clst, fat_cluster_t value)
-{
-	block_t *b, *b1=NULL;
-	aoff64_t offset;
-	uint16_t byte1, byte2;
-	int rc;
-
-	offset = (clst + clst/2);
-	if (offset / BPS(bs) >= SF(bs))
-		return ERANGE;
-	
-	rc = block_get(&b, service_id, RSCNT(bs) + SF(bs) * fatno +
-	    offset / BPS(bs), BLOCK_FLAGS_NONE);
-	if (rc != EOK)
-		return rc;
-
-	byte1 = ((uint8_t*) b->data)[offset % BPS(bs)];
-	bool border = false;
-	/* This cluster access spans a sector boundary. Check only for FAT12 */
-	if ((offset % BPS(bs))+1 == BPS(bs)) {
-		/* Is it last sector of FAT? */
-		if (offset / BPS(bs) < SF(bs)) {
-			/* No. Reading next sector */
-			rc = block_get(&b1, service_id, 1 + RSCNT(bs) +
-				SF(bs)*fatno + offset / BPS(bs), BLOCK_FLAGS_NONE);
-			if (rc != EOK) {
-				block_put(b);
-				return rc;
-			}
-			/*
-			 * Combining value with last byte of current sector and
-			 * first byte of next sector
-			 */
-			byte2 = ((uint8_t*) b1->data)[0];
-			border = true;
-		}
-		else {
-			/* Yes. It is last sector of fat */
-			block_put(b);
-			return ERANGE;
-		}
-	}
-	else
-		byte2 = ((uint8_t*) b->data)[(offset % BPS(bs))+1];
-
-	if (IS_ODD(clst)) {
-		byte1 &= 0x0f;
-		byte2 = 0;
-		value = (value << 4);
-	} else {
-		byte1 = 0;
-		byte2 &= 0xf0;
-		value &= FAT12_MASK;
-	}
-
-	byte1 = byte1 | (value & 0xff);
-	byte2 = byte2 | (value >> 8);
-
-	((uint8_t*) b->data)[(offset % BPS(bs))] = byte1;
-	if (border) {
-		((uint8_t*) b1->data)[0] = byte2;
-
-		b1->dirty = true;
-		rc = block_put(b1);
-		if (rc != EOK) {
-			block_put(b);
-			return rc;
-		}
-	} else 
-		((uint8_t*) b->data)[(offset % BPS(bs))+1] = byte2;
-
-	b->dirty = true;	/* need to sync block */
-	rc = block_put(b);
-	return rc;
-}
-
-/** Set cluster in one instance of FAT. FAT16 version.
- *
- * @param bs		Buffer holding the boot sector for the file system.
- * @param service_id	Service ID for the file system.
- * @param fatno		Number of the FAT instance where to make the change.
- * @param clst		Cluster which is to be set.
- * @param value		Value to set the cluster with.
- *
- * @return		EOK on success or a negative error code.
- */
-int
-fat_set_cluster_fat16(fat_bs_t *bs, service_id_t service_id, unsigned fatno,
-    fat_cluster_t clst, fat_cluster_t value)
-{
-	block_t *b;
-	aoff64_t offset;
-	int rc;
-
-	offset = (clst * FAT16_CLST_SIZE);
-
-	rc = block_get(&b, service_id, RSCNT(bs) + SF(bs) * fatno +
-	    offset / BPS(bs), BLOCK_FLAGS_NONE);
-	if (rc != EOK)
-		return rc;
-
-	*(uint16_t *)(b->data + offset % BPS(bs)) = host2uint16_t_le(value);
-
-	b->dirty = true;	/* need to sync block */
-	rc = block_put(b);
-	return rc;
-}
-
-/** Set cluster in one instance of FAT. FAT32 version.
- *
- * @param bs		Buffer holding the boot sector for the file system.
- * @param service_id	Service ID for the file system.
- * @param fatno		Number of the FAT instance where to make the change.
- * @param clst		Cluster which is to be set.
- * @param value		Value to set the cluster with.
- *
- * @return		EOK on success or a negative error code.
- */
-int
-fat_set_cluster_fat32(fat_bs_t *bs, service_id_t service_id, unsigned fatno,
-    fat_cluster_t clst, fat_cluster_t value)
-{
-	block_t *b;
-	aoff64_t offset;
-	int rc;
-	fat_cluster_t temp;
-
-	offset = (clst * FAT32_CLST_SIZE);
-
-	rc = block_get(&b, service_id, RSCNT(bs) + SF(bs) * fatno +
-	    offset / BPS(bs), BLOCK_FLAGS_NONE);
-	if (rc != EOK)
-		return rc;
-
-	temp = uint32_t_le2host(*(uint32_t *)(b->data + offset % BPS(bs)));
-	temp &= 0xf0000000;
-	temp |= (value & FAT32_MASK);
-	*(uint32_t *)(b->data + offset % BPS(bs)) = host2uint32_t_le(temp);
-
-	b->dirty = true;	/* need to sync block */
-	rc = block_put(b);
 	return rc;
 }
@@ -619,15 +338,18 @@
     fat_cluster_t clst, fat_cluster_t value)
 {
+	block_t *b;
+	fat_cluster_t *cp;
 	int rc;
 
 	assert(fatno < FATCNT(bs));
-
-	if (FAT_IS_FAT12(bs))
-		rc = fat_set_cluster_fat12(bs, service_id, fatno, clst, value);
-	else if (FAT_IS_FAT32(bs))
-		rc = fat_set_cluster_fat32(bs, service_id, fatno, clst, value);
-	else
-		rc = fat_set_cluster_fat16(bs, service_id, fatno, clst, value);
-
+	rc = block_get(&b, service_id, RSCNT(bs) + SF(bs) * fatno +
+	    (clst * sizeof(fat_cluster_t)) / BPS(bs), BLOCK_FLAGS_NONE);
+	if (rc != EOK)
+		return rc;
+	cp = (fat_cluster_t *)b->data +
+	    clst % (BPS(bs) / sizeof(fat_cluster_t));
+	*cp = host2uint16_t_le(value);
+	b->dirty = true;		/* need to sync block */
+	rc = block_put(b);
 	return rc;
 }
@@ -647,11 +369,10 @@
 	uint8_t fatno;
 	unsigned c;
-	fat_cluster_t clst_last1 = FAT_CLST_LAST1(bs);
-	int rc;
-
-	for (fatno = FAT1 + 1; fatno < FATCNT(bs); fatno++) {
+	int rc;
+
+	for (fatno = FAT1 + 1; fatno < bs->fatcnt; fatno++) {
 		for (c = 0; c < nclsts; c++) {
 			rc = fat_set_cluster(bs, service_id, fatno, lifo[c],
-			    c == 0 ? clst_last1 : lifo[c - 1]);
+			    c == 0 ? FAT_CLST_LAST1 : lifo[c - 1]);
 			if (rc != EOK)
 				return rc;
@@ -683,57 +404,94 @@
     fat_cluster_t *mcl, fat_cluster_t *lcl)
 {
-	fat_cluster_t *lifo;    /* stack for storing free cluster numbers */
-	unsigned found = 0;     /* top of the free cluster number stack */
-	fat_cluster_t clst, value, clst_last1 = FAT_CLST_LAST1(bs);
-	int rc = EOK;
+	block_t *blk;
+	fat_cluster_t *lifo;	/* stack for storing free cluster numbers */ 
+	unsigned found = 0;	/* top of the free cluster number stack */
+	unsigned b, c, cl; 
+	int rc;
 
 	lifo = (fat_cluster_t *) malloc(nclsts * sizeof(fat_cluster_t));
 	if (!lifo)
 		return ENOMEM;
+	
 	/*
 	 * Search FAT1 for unused clusters.
 	 */
 	fibril_mutex_lock(&fat_alloc_lock);
-	for (clst=FAT_CLST_FIRST; clst < CC(bs)+2 && found < nclsts; clst++) {
-		rc = fat_get_cluster(bs, service_id, FAT1, clst, &value);
-		if (rc != EOK)
-		break;
-
-		if (value == FAT_CLST_RES0) {
-		/*
-		 * The cluster is free. Put it into our stack
-		 * of found clusters and mark it as non-free.
-		 */
-		lifo[found] = clst;
-		rc = fat_set_cluster(bs, service_id, FAT1, clst,
-		    (found == 0) ?  clst_last1 : lifo[found - 1]);
-		if (rc != EOK)
-			break;
-
-		found++;
+	for (b = 0, cl = 0; b < SF(bs); b++) {
+		rc = block_get(&blk, service_id, RSCNT(bs) + b,
+		    BLOCK_FLAGS_NONE);
+		if (rc != EOK)
+			goto error;
+		for (c = 0; c < BPS(bs) / sizeof(fat_cluster_t); c++, cl++) {
+			/*
+			 * Check if the entire cluster is physically there.
+			 * This check becomes necessary when the file system is
+			 * created with fewer total sectors than how many is
+			 * inferred from the size of the file allocation table
+			 * or when the last cluster ends beyond the end of the
+			 * device.
+			 */
+			if ((cl >= FAT_CLST_FIRST) &&
+			    CLBN2PBN(bs, cl, SPC(bs) - 1) >= TS(bs)) {
+				rc = block_put(blk);
+				if (rc != EOK)
+					goto error;
+				goto out;
+			}
+
+			fat_cluster_t *clst = (fat_cluster_t *)blk->data + c;
+			if (uint16_t_le2host(*clst) == FAT_CLST_RES0) {
+				/*
+				 * The cluster is free. Put it into our stack
+				 * of found clusters and mark it as non-free.
+				 */
+				lifo[found] = cl;
+				*clst = (found == 0) ?
+				    host2uint16_t_le(FAT_CLST_LAST1) :
+				    host2uint16_t_le(lifo[found - 1]);
+				blk->dirty = true;	/* need to sync block */
+				if (++found == nclsts) {
+					/* we are almost done */
+					rc = block_put(blk);
+					if (rc != EOK)
+						goto error;
+					/* update the shadow copies of FAT */
+					rc = fat_alloc_shadow_clusters(bs,
+					    service_id, lifo, nclsts);
+					if (rc != EOK)
+						goto error;
+					*mcl = lifo[found - 1];
+					*lcl = lifo[0];
+					free(lifo);
+					fibril_mutex_unlock(&fat_alloc_lock);
+					return EOK;
+				}
+			}
 		}
-	}
-
-	if (rc == EOK && found == nclsts) {
-		rc = fat_alloc_shadow_clusters(bs, service_id, lifo, nclsts);
-		if (rc == EOK) {
-			*mcl = lifo[found - 1];
-			*lcl = lifo[0];
+		rc = block_put(blk);
+		if (rc != EOK) {
+error:
+			fibril_mutex_unlock(&fat_alloc_lock);
 			free(lifo);
-			fibril_mutex_unlock(&fat_alloc_lock);
-			return EOK;
+			return rc;
 		}
 	}
-
-	/* If something wrong - free the clusters */
-	if (found > 0) {
-		while (found--) {
+out:
+	fibril_mutex_unlock(&fat_alloc_lock);
+
+	/*
+	 * We could not find enough clusters. Now we need to free the clusters
+	 * we have allocated so far.
+	 */
+	while (found--) {
 		rc = fat_set_cluster(bs, service_id, FAT1, lifo[found],
 		    FAT_CLST_RES0);
+		if (rc != EOK) {
+			free(lifo);
+			return rc;
 		}
 	}
-
+	
 	free(lifo);
-	fibril_mutex_unlock(&fat_alloc_lock);
 	return ENOSPC;
 }
@@ -751,14 +509,14 @@
 {
 	unsigned fatno;
-	fat_cluster_t nextc, clst_bad = FAT_CLST_BAD(bs);
+	fat_cluster_t nextc;
 	int rc;
 
 	/* Mark all clusters in the chain as free in all copies of FAT. */
-	while (firstc < FAT_CLST_LAST1(bs)) {
-		assert(firstc >= FAT_CLST_FIRST && firstc < clst_bad);
+	while (firstc < FAT_CLST_LAST1) {
+		assert(firstc >= FAT_CLST_FIRST && firstc < FAT_CLST_BAD);
 		rc = fat_get_cluster(bs, service_id, FAT1, firstc, &nextc);
 		if (rc != EOK)
 			return rc;
-		for (fatno = FAT1; fatno < FATCNT(bs); fatno++) {
+		for (fatno = FAT1; fatno < bs->fatcnt; fatno++) {
 			rc = fat_set_cluster(bs, service_id, fatno, firstc,
 			    FAT_CLST_RES0);
@@ -806,7 +564,7 @@
 		}
 
-		for (fatno = FAT1; fatno < FATCNT(bs); fatno++) {
-			rc = fat_set_cluster(bs, nodep->idx->service_id,
-			    fatno, lastc, mcl);
+		for (fatno = FAT1; fatno < bs->fatcnt; fatno++) {
+			rc = fat_set_cluster(bs, nodep->idx->service_id, fatno,
+			    lastc, mcl);
 			if (rc != EOK)
 				return rc;
@@ -832,5 +590,4 @@
 int fat_chop_clusters(fat_bs_t *bs, fat_node_t *nodep, fat_cluster_t lcl)
 {
-	fat_cluster_t clst_last1 = FAT_CLST_LAST1(bs);
 	int rc;
 	service_id_t service_id = nodep->idx->service_id;
@@ -859,7 +616,7 @@
 
 		/* Terminate the cluster chain in all copies of FAT. */
-		for (fatno = FAT1; fatno < FATCNT(bs); fatno++) {
+		for (fatno = FAT1; fatno < bs->fatcnt; fatno++) {
 			rc = fat_set_cluster(bs, service_id, fatno, lcl,
-			    clst_last1);
+			    FAT_CLST_LAST1);
 			if (rc != EOK)
 				return rc;
@@ -916,13 +673,14 @@
 
 	/* Check number of FATs. */
-	if (FATCNT(bs) == 0)
+	if (bs->fatcnt == 0)
 		return ENOTSUP;
 
 	/* Check total number of sectors. */
-	if (TS(bs) == 0)
+
+	if (bs->totsec16 == 0 && bs->totsec32 == 0)
 		return ENOTSUP;
 
 	if (bs->totsec16 != 0 && bs->totsec32 != 0 &&
-	    bs->totsec16 != bs->totsec32)
+	    bs->totsec16 != bs->totsec32) 
 		return ENOTSUP;
 
@@ -932,5 +690,5 @@
 
 	/* Check number of sectors per FAT. */
-	if (SF(bs) == 0)
+	if (bs->sec_per_fat == 0)
 		return ENOTSUP;
 
@@ -942,9 +700,11 @@
 	 * sanitized to support file systems with this property.
 	 */
-	if (!FAT_IS_FAT32(bs) && (RDE(bs) * sizeof(fat_dentry_t)) % BPS(bs) != 0)
+	if ((uint16_t_le2host(bs->root_ent_max) * sizeof(fat_dentry_t)) %
+	    uint16_t_le2host(bs->bps) != 0)
 		return ENOTSUP;
 
 	/* Check signature of each FAT. */
-	for (fat_no = 0; fat_no < FATCNT(bs); fat_no++) {
+
+	for (fat_no = 0; fat_no < bs->fatcnt; fat_no++) {
 		rc = fat_get_cluster(bs, service_id, fat_no, 0, &e0);
 		if (rc != EOK)
@@ -963,6 +723,5 @@
 		 * set to one.
 		 */
-		if (!FAT_IS_FAT12(bs) && 
-			((e0 >> 8) != (FAT_MASK(bs) >> 8) || e1 != FAT_MASK(bs)))
+		if ((e0 >> 8) != 0xff || e1 != 0xffff)
 			return ENOTSUP;
 	}
@@ -973,3 +732,3 @@
 /**
  * @}
- */
+ */ 
Index: uspace/srv/fs/fat/fat_fat.h
===================================================================
--- uspace/srv/fs/fat/fat_fat.h	(revision 375ab5e571cc53eeb2aa803a8e86052b51d7ad00)
+++ uspace/srv/fs/fat/fat_fat.h	(revision 7fadb6526b88d8a8d0bbeb5d5997969a53e7e66d)
@@ -1,5 +1,4 @@
 /*
  * Copyright (c) 2008 Jakub Jermar
- * Copyright (c) 2011 Oleg Romanenko
  * All rights reserved.
  *
@@ -30,5 +29,5 @@
 /** @addtogroup fs
  * @{
- */
+ */ 
 
 #ifndef FAT_FAT_FAT_H_
@@ -41,23 +40,10 @@
 #define FAT1		0
 
-#define FAT_CLST_RES0	  0
-#define FAT_CLST_RES1	  1
-#define FAT_CLST_FIRST	  2
-
-#define FAT32_CLST_BAD    0x0ffffff7
-#define FAT32_CLST_LAST1  0x0ffffff8
-#define FAT32_CLST_LAST8  0x0fffffff
-
-#define FAT12_MASK        0x0fff
-#define FAT16_MASK        0xffff
-#define FAT32_MASK        0x0fffffff
-
-#define FAT12_CLST_MAX    4085
-#define FAT16_CLST_MAX    65525
-
-/* Size in bytes for cluster value of FAT */
-#define FAT12_CLST_SIZE   2
-#define FAT16_CLST_SIZE   2
-#define FAT32_CLST_SIZE   4
+#define FAT_CLST_RES0	0x0000
+#define FAT_CLST_RES1	0x0001
+#define FAT_CLST_FIRST	0x0002
+#define FAT_CLST_BAD	0xfff7
+#define FAT_CLST_LAST1	0xfff8
+#define FAT_CLST_LAST8  0xffff
 
 /* internally used to mark root directory's parent */
@@ -66,34 +52,4 @@
 #define FAT_CLST_ROOT		FAT_CLST_RES1
 
-/*
- * Convenience macros for computing some frequently used values from the
- * primitive boot sector members.
- */
-#define RDS(bs)	  ((sizeof(fat_dentry_t) * RDE((bs))) / BPS((bs))) + \
-		   (((sizeof(fat_dentry_t) * RDE((bs))) % BPS((bs))) != 0)
-#define SSA(bs)	  (RSCNT((bs)) + FATCNT((bs)) * SF((bs)) + RDS(bs))
-#define DS(bs)	  (TS(bs) - SSA(bs))
-#define CC(bs)	  (DS(bs) / SPC(bs))
-
-#define FAT_IS_FAT12(bs)	(CC(bs) < FAT12_CLST_MAX)
-#define FAT_IS_FAT16(bs) \
-    ((CC(bs) >= FAT12_CLST_MAX) && (CC(bs) < FAT16_CLST_MAX))
-#define FAT_IS_FAT32(bs)	(CC(bs) >= FAT16_CLST_MAX)
-
-#define FAT_CLST_SIZE(bs) \
-    (FAT_IS_FAT32(bs) ? FAT32_CLST_SIZE : FAT16_CLST_SIZE)
-
-#define FAT_MASK(bs) \
-    (FAT_IS_FAT12(bs) ? FAT12_MASK : \
-    (FAT_IS_FAT32(bs) ? FAT32_MASK : FAT16_MASK))
-
-#define FAT_CLST_LAST1(bs)      (FAT32_CLST_LAST1 & FAT_MASK((bs)))
-#define FAT_CLST_LAST8(bs)      (FAT32_CLST_LAST8 & FAT_MASK((bs)))
-#define FAT_CLST_BAD(bs)        (FAT32_CLST_BAD & FAT_MASK((bs)))
-
-#define FAT_ROOT_CLST(bs) \
-    (FAT_IS_FAT32(bs) ? uint32_t_le2host(bs->fat32.root_cluster) : \
-    FAT_CLST_ROOT)
-
 /* forward declarations */
 struct block;
@@ -101,10 +57,10 @@
 struct fat_bs;
 
-typedef uint32_t fat_cluster_t;
+typedef uint16_t fat_cluster_t;
 
-#define fat_clusters_get(numc, bs, sid, fc) \
-    fat_cluster_walk((bs), (sid), (fc), NULL, (numc), (uint32_t) -1)
+#define fat_clusters_get(numc, bs, dh, fc) \
+    fat_cluster_walk((bs), (dh), (fc), NULL, (numc), (uint16_t) -1)
 extern int fat_cluster_walk(struct fat_bs *, service_id_t, fat_cluster_t,
-    fat_cluster_t *, uint32_t *, uint32_t);
+    fat_cluster_t *, uint16_t *, uint16_t);
 
 extern int fat_block_get(block_t **, struct fat_bs *, struct fat_node *,
@@ -122,18 +78,6 @@
 extern int fat_alloc_shadow_clusters(struct fat_bs *, service_id_t,
     fat_cluster_t *, unsigned);
-extern int fat_get_cluster_fat12(struct fat_bs *, service_id_t, unsigned,
-    fat_cluster_t, fat_cluster_t *);
-extern int fat_get_cluster_fat16(struct fat_bs *, service_id_t, unsigned,
-    fat_cluster_t, fat_cluster_t *);
-extern int fat_get_cluster_fat32(struct fat_bs *, service_id_t, unsigned,
-    fat_cluster_t, fat_cluster_t *);
 extern int fat_get_cluster(struct fat_bs *, service_id_t, unsigned,
     fat_cluster_t, fat_cluster_t *);
-extern int fat_set_cluster_fat12(struct fat_bs *, service_id_t, unsigned,
-    fat_cluster_t, fat_cluster_t);
-extern int fat_set_cluster_fat16(struct fat_bs *, service_id_t, unsigned,
-    fat_cluster_t, fat_cluster_t);
-extern int fat_set_cluster_fat32(struct fat_bs *, service_id_t, unsigned,
-    fat_cluster_t, fat_cluster_t);
 extern int fat_set_cluster(struct fat_bs *, service_id_t, unsigned,
     fat_cluster_t, fat_cluster_t);
